; 

    include \masm32\include\masm32rt.inc
    include \masm32\include\pdh.inc

    includelib  \masm32\lib\pdh.lib

    include hdactmon.inc

; 

    .code

start:

    invoke GetModuleHandle, NULL
    mov   hInstance, eax

    invoke GetCommandLine
    mov   commandLine, eax

    invoke WinMain, hInstance, NULL, commandLine, SW_SHOWDEFAULT
    invoke ExitProcess, eax

; 

WinMain proc hInst:DWORD,hPrevInst:DWORD,cmdLine:DWORD,cmdShow:DWORD

    LOCAL wc  :WNDCLASSEX
    LOCAL msg :MSG    

    mov   nSize, SIZEOF machineName
    invoke GetComputerName, ADDR machineName, ADDR nSize
    mov   pcpe.szMachineName, OFFSET machineName
    mov   pcpe.szObjectName, OFFSET objectName
    mov   pcpe.szCounterName, OFFSET counterName
    mov   pcpe.szCounterName, OFFSET counterName
    mov   pcpe.szInstanceName, OFFSET instanceName
    mov   pcpe.szParentInstance, NULL
    mov   pcpe.dwInstanceIndex, -1

    mov   nSize, SIZEOF counterPath
    invoke PdhMakeCounterPath, ADDR pcpe, ADDR counterPath, ADDR nSize, 0
    .IF eax != ERROR_SUCCESS
      MsgBox 0,"PdhMakeCounterPath failed",NULL,0
      jmp   fail
    .ENDIF       

    invoke PdhOpenQuery, NULL, NULL, ADDR hQuery
    .IF eax != ERROR_SUCCESS
      MsgBox 0,"PdhOpenQuery failed", NULL,0
      jmp   fail
    .ENDIF

    invoke PdhAddCounter, hQuery, ADDR counterPath, NULL, ADDR hCounter
    .IF eax != ERROR_SUCCESS
      MsgBox 0,"PdhAddCounter failed",NULL,0
      jmp   fail
    .ENDIF

    mov   wc.cbSize,        sizeof WNDCLASSEX
    mov   wc.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wc.lpfnWndProc,   OFFSET WndProc
    mov   wc.cbClsExtra,    NULL
    mov   wc.cbWndExtra,    NULL
    m2m   wc.hInstance,     hInst
    mov   wc.hbrBackground, COLOR_WINDOW+1
    mov   wc.lpszMenuName,  NULL
    mov   wc.lpszClassName, OFFSET className
    mov   wc.hIcon,         NULL
    mov   wc.hCursor,       NULL
    mov   wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            ADDR windowName,
                            WS_OVERLAPPEDWINDOW,
                            0,0,240,160,
                            NULL, NULL,
                            hInst, NULL
    mov   hWnd, eax

    invoke SetTimer, hWnd, ID_TIMER, 10, NULL

    ;invoke ShowWindow, hWnd, SW_SHOWNORMAL   ; debug only
    ;invoke UpdateWindow, hWnd                ; debug only

  msgLoop:

    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF eax != 0
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage, ADDR msg
      jmp   msgLoop
    .ENDIF

    invoke PdhCloseQuery, hQuery
    invoke KillTimer, hWnd, ID_TIMER

    return msg.wParam

  fail:

    return 0

WinMain endp

; 

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL pt:POINT

    .IF uMsg == WM_CREATE

      mov   hIcon000, rv(LoadImage,hInstance,1000,IMAGE_ICON,0,0,NULL)
      mov   hIcon025, rv(LoadImage,hInstance,1025,IMAGE_ICON,0,0,NULL)
      mov   hIcon050, rv(LoadImage,hInstance,1050,IMAGE_ICON,0,0,NULL)
      mov   hIcon075, rv(LoadImage,hInstance,1075,IMAGE_ICON,0,0,NULL)
      mov   hIcon100, rv(LoadImage,hInstance,1100,IMAGE_ICON,0,0,NULL)

      invoke CreatePopupMenu
      mov   hPopupMenu, eax
      invoke AppendMenu, hPopupMenu, MF_STRING, IDM_EXIT, chr$("Exit")

      mov   nid.cbSize, SIZEOF NOTIFYICONDATA
      m2m   nid.hwnd, hWin
      mov   nid.uID, IDI_TASKBARICON
      mov   nid.uFlags, NIF_ICON+NIF_MESSAGE+NIF_TIP
      mov   nid.uCallbackMessage, WM_CALLBACK
      m2m   nid.hIcon, hIcon000
      invoke lstrcpy, ADDR nid.szTip, ADDR windowName
      invoke Shell_NotifyIcon, NIM_ADD, ADDR nid

    .ELSEIF uMsg == WM_DESTROY

      invoke PostQuitMessage, NULL
      return 0

    .ELSEIF uMsg == WM_TIMER

      call TimerProc

    .ELSEIF uMsg == WM_COMMAND

      .IF lParam == 0
        invoke Shell_NotifyIcon, NIM_DELETE, ADDR nid
        mov eax, wParam
        .IF ax == IDM_EXIT
          invoke DestroyWindow, hWin
        .ENDIF
      .ENDIF

    .ELSEIF uMsg == WM_CALLBACK

      .IF wParam == IDI_TASKBARICON
        .IF lParam == WM_RBUTTONDOWN

          ; -------------------------------------------------------
          ; This code temporarily sets the foreground window to
          ; the current window to correct a problem with the menu
          ; not disappearing when the user clicks outside the menu.
          ; Tested under Windows 2000 only. See the PSDK or MSDN
          ; documentation for TrackPopupMenu.
          ; -------------------------------------------------------

          invoke GetForegroundWindow
          push  eax
          invoke SetForegroundWindow, hWin

          invoke GetCursorPos,addr pt
          invoke TrackPopupMenu, hPopupMenu, TPM_RIGHTALIGN,
            pt.x, pt.y, NULL, hWin, NULL

          pop   eax
          invoke SetForegroundWindow, eax

        .ENDIF
      .ENDIF

    .ENDIF

    invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret

WndProc endp

; 

TimerProc proc

    invoke PdhCollectQueryData, hQuery
    invoke PdhGetFormattedCounterValue,hCounter,PDH_FMT_LONG,0,ADDR pfc
    .IF pfc.CStatus == PDH_CSTATUS_VALID_DATA

        mov   eax, pfc.longValue

        ; -------------------------------------------------------
        ; No single drive will exceed 50%, so as test double the
        ; value to allow one drive to reach 100%.
        ; -------------------------------------------------------
        shl   eax, 1

        ; -----------------------------------------------------------
        ; To soften the appearance of the icon animation average the
        ; disk time over ten timer periods (100ms total). Updating
        ; the icon only when the disk time value changes reduces the
        ; CPU load, and improves the appearance if for some reason
        ; the sync with vertical retrace will not work.
        ; -----------------------------------------------------------

        add   queryTotal, eax
        add   queryCount, 1
        .IF queryCount == 10
            mov   eax, queryTotal
            xor   edx, edx
            mov   ecx, 10
            div   ecx
            cmp   edx, 5
            jb    @F
            add   eax, 1
          @@:  
            mov   queryCount, 0
            mov   queryTotal, 0
            .IF eax != prevValue
                mov prevValue, eax
                Switch eax
                  Case 0
                    m2m   nid.hIcon, hIcon000
                  Case 1,25
                    m2m   nid.hIcon, hIcon025
                  Case 26,50
                    m2m   nid.hIcon, hIcon050
                  Case 51,75
                    m2m   nid.hIcon, hIcon075
                  Case 76,100
                    m2m   nid.hIcon, hIcon100
                EndSw
            .ENDIF

            invoke Shell_NotifyIcon, NIM_MODIFY, ADDR nid

        .ENDIF
    .ENDIF
    ret
TimerProc endp

; 

end start
